#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Jul  9 18:39:03 2020

@author: lucia
"""

import math


'''
===============================================================================
Modelo Hodgkin-Huxley
EDOs
===============================================================================
'''
def Hodgkin_Huxley(t, S, E_N, E_K, g_N_bar, g_K_bar, g_leak, E_leak, C_M):

    # Obtencion de valores.....................................................
    # Potencial de Membrana
    V = S[0]
    # Activadores
    m = S[1]
    h = S[2]
    n = S[3]
    
    # Resolución de dm/dt......................................................
    am = 0.1*(V+35)/(1.0 - math.exp(-(V+35)/10.0));
    bm = 4.0*math.exp(-(V+60)/18.0);
    dmdt = am*(1-m) - bm*m;

    # Resolución de dh/dt......................................................
    ah = 0.07*math.exp(-(V+60)/20.0)
    bh = 1.0/(1 + math.exp(-(V+30)/10.0))
    dhdt = ah*(1-h) - bh*h
    
    # Resolución de dn/dt......................................................
    an = 0.01*(V+50)/(1.0 - math.exp(-(V+50)/10.0))
    bn = 0.125*math.exp(-(V+60)/80.0)
    dndt = an*(1-n) - bn*n
    
    # Calculo de corrientes ionicas............................................
    # Colocar la expresion de las corrientes conforme las conductancias y los
    #valores de m, n y h
    I_K = math.pow(n,4)*g_K_bar*(V-E_K);
    I_N = math.pow(m,3)*h*g_N_bar*(V-E_N);
    I_leak = g_leak*(V-E_leak);
    
    # Corriente de excitacion..................................................
    # Debe ser un pulso de 1 ms de valor 16.85nA en un tiempo a elección dentro
    #del intervalo.
    I=16.85 #mu A
    '''
    I = 0;
    if (t>=5.0) and (t<6.0): #ms
        I = 16.85 #nA
'''
    # Derivada del potencial de Acción.........................................
    #Expresion de dV/dt
    dVdt = (I - (I_K+I_N+I_leak))/C_M
    
    #Salida   
    dS =  [dVdt, dmdt, dhdt, dndt]
    return dS